#include "utils/generate_project_directory.hpp"
#include <filesystem>

namespace fs = std::filesystem;

std::string generate_project_directory(const std::string& project_name) {
  const char* home_dir = std::getenv("HOME");
  if (!home_dir) {
    throw std::runtime_error("Could not get HOME environment variable");
  }
  fs::path base_dir(home_dir);

  fs::path app_subdir(".local/share/cl3/projets");
  fs::path app_dir = base_dir / app_subdir;

  if (!fs::exists(app_dir)) {
    fs::create_directory(app_dir);
  }

  fs::path new_dir_path = app_dir / project_name;

  if (fs::exists(new_dir_path)) {
    throw std::runtime_error("Project exists");
  }

  fs::create_directory(new_dir_path);

  return new_dir_path.string();
}
